/*
   1101

*/
#include <util/delay.h>
#include <avr/io.h>
#include <stdlib.h>

#include "cc1101.h"
#include "atmega328p.h"
//#include "uart.h"

unsigned char ccxxx0_Read(unsigned char addr)
{
    unsigned char x;
	PORTB &= ~(1 << CSN);

	while(PINB & (1 << GDO1_SO));

    SPDR = (addr | 0x80);
	while(!(SPSR & (1<<SPIF)));
    x = SPDR; // ocisti ga

    SPDR = 0;
	while(!(SPSR & (1<<SPIF)));
    x = SPDR;

    PORTB |= (1 << CSN);

    return x;
}

unsigned char ccxxx0_Write(unsigned char addr, unsigned char dat)
{
    unsigned char x;
	PORTB &= ~(1 << CSN);

	while(PINB & (1 << GDO1_SO));

    SPDR = addr;
	while(!(SPSR & (1<<SPIF)));
	x = SPDR; // ocisti ga

    SPDR = dat;
	while(!(SPSR & (1<<SPIF)));
    x = SPDR;

    PORTB |= (1 << CSN);

    return x;
}

unsigned char ccxxx0_Strobe(unsigned char addr)
{
    unsigned char x;
	PORTB &= ~(1 << CSN);

	while(PINB & (1 << GDO1_SO));

    SPDR = addr;
	while(!(SPSR & (1<<SPIF)));
    x = SPDR;

    PORTB |= (1 << CSN);

    return x;
}

void ccxxx0_ReadBurst(unsigned char addr, unsigned char* dataPtr, unsigned int dataCount)
{
	unsigned char x;

	PORTB &= ~(1 << CSN);

	while(PINB & (1 << GDO1_SO));

    SPDR = (addr | 0xc0);
	while(!(SPSR & (1<<SPIF)));
	x = SPDR; // ocisti ga

	while(dataCount) {
	    SPDR = 0;
		while(!(SPSR & (1<<SPIF)));

	    *dataPtr++ = SPDR;
		dataCount--;
	}

    PORTB |= (1 << CSN);
}

void ccxxx0_WriteBurst(unsigned char addr, unsigned char* dataPtr, unsigned int dataCount)
{
	unsigned char x;

	PORTB &= ~(1 << CSN);

	while(PINB & (1 << GDO1_SO));

    SPDR = addr | 0x40;
	while(!(SPSR & (1<<SPIF)));
	x = SPDR; // ocisti ga

	while(dataCount) {
	    SPDR = *dataPtr++;
		while(!(SPSR & (1<<SPIF)));

		dataCount--;
	}

    PORTB |= (1 << CSN);
}

void ccxxx0_PowerOnReset()
{
	unsigned char x;

    PORTB |= (1 << CSN);
	_delay_us(1);
	PORTB &= ~(1 << CSN);
	_delay_us(1);
    PORTB |= (1 << CSN);
	_delay_us(41);

	PORTB &= ~(1 << CSN);

	while(PINB & (1 << GDO1_SO));

	_delay_us(50); //PAUZA KOJA PO TEORIJI NE TREBA

    SPDR = CCxxx0_SRES;
	while(!(SPSR & (1<<SPIF)));
	x = SPDR; // ocisti ga

	while(PINB & (1 << GDO1_SO));

	_delay_us(50); //PAUZA KOJA PO TEORIJI NE TREBA

    PORTB |= (1 << CSN);
}


void ccxxx0_Setup(const RF_SETTINGS* settings)
{
    // Write register settings


	/*

	uint8 IOCFG2;     // GDO2 Output Pin Configuration
    uint8 IOCFG0;     // GDO0 Output Pin Configuration
    uint8 FIFOTHR;    // RX FIFO and TX FIFO Thresholds
    uint8 PKTCTRL0;   // Packet Automation Control
    uint8 FSCTRL1;    // Frequency Synthesizer Control
    uint8 FREQ2;      // Frequency Control Word, High Byte
    uint8 FREQ1;      // Frequency Control Word, Middle Byte
    uint8 FREQ0;      // Frequency Control Word, Low Byte
    uint8 MDMCFG4;    // Modem Configuration
    uint8 MDMCFG3;    // Modem Configuration
    uint8 MDMCFG2;    // Modem Configuration
    uint8 MDMCFG1;    // Modem Configuration
    uint8 DEVIATN;    // Modem Deviation Setting
    uint8 MCSM0;      // Main Radio Control State Machine Configuration
    uint8 FOCCFG;     // Frequency Offset Compensation Configuration
    uint8 WORCTRL;    // Wake On Radio Control
    uint8 FREND0;     // Front End TX Configuration
    uint8 FSCAL3;     // Frequency Synthesizer Calibration
    uint8 FSCAL2;     // Frequency Synthesizer Calibration
    uint8 FSCAL1;     // Frequency Synthesizer Calibration
    uint8 FSCAL0;     // Frequency Synthesizer Calibration
    uint8 TEST2;      // Various Test Settings
    uint8 TEST1;      // Various Test Settings
    uint8 TEST0;      // Various Test Settings


	*/
	ccxxx0_Write(CCxxx0_IOCFG2,   settings->IOCFG2);
    ccxxx0_Write(CCxxx0_IOCFG0,   settings->IOCFG0);
	ccxxx0_Write(CCxxx0_FIFOTHR,  settings->FIFOTHR);
	ccxxx0_Write(CCxxx0_PKTCTRL0,  settings->PKTCTRL0);
    ccxxx0_Write(CCxxx0_FSCTRL1,  settings->FSCTRL1);
    ccxxx0_Write(CCxxx0_FREQ2,    settings->FREQ2);
    ccxxx0_Write(CCxxx0_FREQ1,    settings->FREQ1);
    ccxxx0_Write(CCxxx0_FREQ0,    settings->FREQ0);
    ccxxx0_Write(CCxxx0_MDMCFG4,  settings->MDMCFG4);
    ccxxx0_Write(CCxxx0_MDMCFG3,  settings->MDMCFG3);
    ccxxx0_Write(CCxxx0_MDMCFG2,  settings->MDMCFG2);
    ccxxx0_Write(CCxxx0_MDMCFG1,  settings->MDMCFG1);
    ccxxx0_Write(CCxxx0_DEVIATN,  settings->DEVIATN);
    ccxxx0_Write(CCxxx0_MCSM0 ,   settings->MCSM0 );
    ccxxx0_Write(CCxxx0_FOCCFG,   settings->FOCCFG);
	ccxxx0_Write(CCxxx0_WORCTRL,   settings->WORCTRL);
	ccxxx0_Write(CCxxx0_FREND0,   settings->FREND0);
    ccxxx0_Write(CCxxx0_FSCAL3,   settings->FSCAL3);
    ccxxx0_Write(CCxxx0_FSCAL2,   settings->FSCAL2);
	ccxxx0_Write(CCxxx0_FSCAL1,   settings->FSCAL1);
    ccxxx0_Write(CCxxx0_FSCAL0,   settings->FSCAL0);
 	ccxxx0_Write(CCxxx0_TEST2,    settings->TEST2);
    ccxxx0_Write(CCxxx0_TEST1,    settings->TEST1);
    ccxxx0_Write(CCxxx0_TEST0,    settings->TEST0);


}
