/*

      

rfSettings  -     Smart RF Studio 
     1101 

*/
#define BMP_PORT		PORTB
#define BMP180_OFF		BMP_PORT|=1<<BMP180_POWER_PIN
#define BMP180_ON		BMP_PORT&=~(1<<BMP180_POWER_PIN)

#define DEBUG_ON   //  
//#define HF_CARRIER_TEST  //    
//#define F_CPU 8000000L
//=============================================
#define BMP180_POWER_PIN				 2
#define BEEP_PAUSE 						 3000 //            
#define PERIOD_BEEP						 15 //15      = (BEEP_PAUSE/1000)*PERIOD_BEEP  
#define U_POROG							 3050   //            
#define BUS								 OWI_PIN_1   //     ,     OWIPolled.h
#define U_POROG_NO_TELEMETRY			 3100  //              
#define U_POROG_MIN_POW					 2900  //        
#define TENDBM							 0
#define SEVENDBM						 1
// 
struct 
	{
	unsigned int low_voltage:1;  //         
	unsigned int low_voltage_no_telemetry:1;  //        
	unsigned int low_voltage_min_pow:1; //        
	} flags;



//      
const uint32_t  pow10Table32[]=
{
    1000000000ul,// digit 10
    100000000ul, // digit 9
    10000000ul,	 // digit 8
    1000000ul, 	// digit 7
    100000ul,	// digit 6
    10000ul,	// digit 5 
    1000ul,		// digit 4
    100ul,		// digit 3 
    10ul,		// digit 2
    1ul			// digit 1
};


//   
unsigned char cw_str[]={"V R4N BALLON N5 UHF AND 80 M QRPP TEST ON 3579"};   // 
unsigned char cw_str_vbatt[11]={" VBATT XXX"};  //    
unsigned char cw_str_temp[35];   //   
unsigned char cw_str_press[35];
unsigned char cw_str_end[]={" K"};  //   
unsigned int adc;  //   

// Rf settings for CC1101
RF_SETTINGS rfSettings = {
    0x0B,  // IOCFG2        GDO2 Output Pin Configuration
    0x4C,  // IOCFG0        GDO0 Output Pin Configuration
    0x47,  // FIFOTHR       RX FIFO and TX FIFO Thresholds
    0x32,  // PKTCTRL0      Packet Automation Control
    0x06,  // FSCTRL1       Frequency Synthesizer Control
    0x10,  // FREQ2         Frequency Control Word, High Byte    437.999786 
    0xD8,  // FREQ1         Frequency Control Word, Middle Byte
    0x9D,  // FREQ0         Frequency Control Word, Low Byte
    0xF3,  // MDMCFG4       Modem Configuration
    0x83,  // MDMCFG3       Modem Configuration
    0x30,  // MDMCFG2       Modem Configuration
    0x00,  // MDMCFG1       Modem Configuration
    0x15,  // DEVIATN       Modem Deviation Setting
    0x18,  // MCSM0         Main Radio Control State Machine Configuration
    0x16,  // FOCCFG        Frequency Offset Compensation Configuration
    0xFB,  // WORCTRL       Wake On Radio Control
    0x11,  // FREND0        Front End TX Configuration
    0xE9,  // FSCAL3        Frequency Synthesizer Calibration
    0x2A,  // FSCAL2        Frequency Synthesizer Calibration
    0x00,  // FSCAL1        Frequency Synthesizer Calibration
    0x1F,  // FSCAL0        Frequency Synthesizer Calibration
    0x81,  // TEST2         Various Test Settings
    0x35,  // TEST1         Various Test Settings
    0x09,  // TEST0         Various Test Settings
};






// PATABLE ([0]=+10 dBm, [1]=+7 dBm output power)
unsigned char paTable[] = {
	0xC0 , 0xC8 // 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0
	//0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03
	};

//=============================================================

// 
void u_measure(void);
void inttosymb_cycle_sub(int32_t value, uint8_t *buffer, uint8_t position, uint8_t quantity, uint8_t digit);
uint8_t temp_measure(void);
void beeper (unsigned char i, unsigned char *symb);
