//  UART


#include "atmega328p.h"
#include <avr/io.h>



void uart_init(unsigned int bauddiv)
		{
		UBRR0H=(unsigned char)(bauddiv>>8);
		UBRR0L=(unsigned char)(bauddiv);
		UCSR0B=(1<<TXEN0)|(1<<RXEN0); //    
		UCSR0C=(1<<UCSZ01)|(1<<UCSZ00);   // 8  , 1  
		}

	void uart_tx(unsigned char buff)
		{
		while ( !(UCSR0A&(1<<UDRE0)) );
		UDR0=buff;
		}

void uart_set_baudrate(unsigned int bauddiv)
	{
	UBRR0H=(unsigned char)(bauddiv>>8);
	UBRR0L=(unsigned char)(bauddiv);
	}

void uart_tx_string(uint8_t *string)
	{
	while (*string != 0x00)
		{
		uart_tx( *(string++ ) );
		}
	}
	
uint8_t uart_rx_char(void)
	{
	while ( !(UCSR0A & (1<<RXC0)) );
	return UDR0;
	}
