/*
     UART
*/

#ifndef UART_H
#define UART_H


#include <avr/io.h>
#include <stdlib.h>
#include "atmega328p.h"

//=================

#define UART_RX_EN			UCSR0B|=1<<RXEN0
#define UART_TX_EN			UCSR0B|=1<<TXEN0
#define UART_RXCIE0_ON		UCSR0B|=1<<RXCIE0
#define UART_TXCIE0_ON		UCSR0B|=1<<TXCIE0

#define UART_RX_DIS			UCSR0B&=~(1<<RXEN0)
#define UART_TX_DIS			UCSR0B&=~(1<<TXEN0)
#define UART_RXCIE0_OFF		UCSR0B&=~(1<<RXCIE0)
#define UART_TXCIE0_OFF		UCSR0B&=~(1<<TXCIE0)
//========================


void uart_set_baudrate(unsigned int bauddiv);  //  
void uart_tx_string(unsigned char *string);
void uart_init(unsigned int bauddiv);  // 
void uart_tx(unsigned char buff);   // 
uint8_t uart_rx_char(void);  //  


#endif
